	include	<p16F84.inc>
	__CONFIG   _RC_OSC &_CP_OFF &_PWRTE_ON &_WDT_OFF  
	initA	equ b'00011111'	; 1 - 室 0 - 室
	initB	equ b'00000001'
	TRISA	equ 85h
	TRISB	equ 86h
	PORTA	equ 05h
	OUT_B	equ 06h
	RP0		equ	5
	org 0x0
	SCRATCH EQU 0Ch
	goto init

init	
	bsf STATUS,RP0	; set mem bank 1
	movlw initA	; ⠭ 室-室
	movwf TRISA
	movlw initB
	movwf TRISB
	bcf STATUS,RP0	;set mem bank 0

step01
	call wait_for	
	movlw b'00000110'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step12	
step02
	call wait_for	
	movlw b'00001110'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step01	
step03
	call wait_for	
	movlw b'00001100'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step02	
step04
	call wait_for	
	movlw b'00011100'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step03	
step05
	call wait_for	
	movlw b'00011000'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step04	
step06
	call wait_for	
	movlw b'00111000'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step05	
step07
	call wait_for	
	movlw b'00110000'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step06	
step08
	call wait_for	
	movlw b'01110000'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step07	
step09
	call wait_for	
	movlw b'01100000'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step08	
step10
	call wait_for	
	movlw b'01100010'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step09	
step11
	call wait_for	
	movlw b'01000010'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step10	
step12
	call wait_for	
	movlw b'01000110'
	movwf OUT_B
	btfss PORTA,1 			;if in'1*' - right 
	goto step11
	goto step01	

wait_for
	movlw	b'00011100'	
	andwf	PORTA,0
	sublw	b'00011100'	
	btfsc	STATUS,Z
	goto	wait_1	
	clrf	PORTB	;ᠬ ⮩ ᯮᮡ - 몫砥 ࠧ 
	goto	$	;⠭ - १ 	
wait_1
	btfsc PORTA, 0 ; waight for step
	goto wait_1	
wait_0
	btfss PORTA, 0 ; waight for step
	goto wait_0	
	return
end
